<?php

namespace App\Datatables\Admin\Shop;

use App\Datatables\ParentDataTable as DataTable;
use App\Models\Shop\Producer;
use App\Repositories\Shop\Producers;
use App\Repositories\Shop\Tags;
use Yajra\DataTables\Html\Column;

class ProducersDataTable extends DataTable
{
    public $model_name = 'producers';

    public function query(Producer $model)
    {
        $model = $model::with(['image', 'tags'])->withCount(['Merchandises', 'tags', 'images']);

        return $this->buildQuery($model);
    }

    public function modifier($datatables)
    {
        $datatables
            ->editColumn('thumb', function (Producer $producer) {
                return Producers::getThumb($producer->image, false);
            })
            ->editColumn('tags2', function (Producer $producer) {
                $html = '';
                foreach ($producer->tags as $tag) {
                    $html .= Tags::getTagHtml($tag);
                }

                return $html;
            })
            ->rawColumns(['thumb', 'tags2', 'action']);

        return parent::modifier($datatables);
    }

    protected function getColumns()
    {
        return [
            Column::make('thumb')->title('')->searchable(false)->orderable(false)->width(40)->class('text-center'),
            Column::make('name')->title('Nom'),
            Column::make('tags2')->title('Tags')->searchable(false)->orderable(false),
            Column::make('merchandises_count')->title('#Marchandises')->class('text-right')->searchable(false),
            // Column::make('tags_count')->title('#Tag')->class('text-right')->searchable(false),
            // Column::make('images_count')->title('#Pho')->class('text-right')->searchable(false),
            $this->makeColumnButtons(),
        ];
    }
}
